#include "CDRECORDCmdLine.h"
#include "Application1.h"
#include "ConfigFields.h"
#include "ErrorBox.h"
#include "HLM.h"


extern HLM *H;

status_t CDRECORD_CommandLine(const char **argv, int *argc, bool multisession) {
	Application1	*app=(Application1 *)be_app;
	Window1	*window1=(Window1 *)app->window1;
	View1		*view1=(View1 *)window1->view1;
	BString		str="";

	argv[(*argc)++] = strdup(app->CM->GetString(PATH_TO_CDRECORD)->String());
	// device number
	str="dev=";
	str << app->deviceCV->GetWriterDeviceNumber();
	argv[(*argc)++] = strdup(str.String());

	// verbose mode	
	argv[(*argc)++] = strdup("-v");

	// burnproof
	if (app->heliosCV->IsBurnproof())
		argv[(*argc)++] = strdup("driveropts=burnproof");

	// overburning		
	if (app->heliosCV->IsOverburning())
		argv[(*argc)++] = strdup("-overburn");

	// FIFO buffer size
	if (app->heliosCV->GetFIFOSize()!=4) {
		str.SetTo("fs=");
		str << app->heliosCV->GetFIFOSize() << "M";
		argv[(*argc)++] = strdup(str.String());
	}

	// wait for data input stream
	argv[(*argc)++] = strdup("-waiti");
	
	str="-speed=";
	str << app->heliosCV->GetWriterSpeed();
	argv[(*argc)++] = strdup(str.String());

//	if (!window1->view1->IsMultisession())
		if (!app->heliosCV->IsFixating())
			argv[(*argc)++] = strdup("-nofix");

	if (app->heliosCV->IsSimulation())
		argv[(*argc)++] = strdup("-dummy");
	
	switch(view1->CDType()) {
		case CDEXTRA_INDEX: {
			break;
		}
		
		

		default: {
			if (multisession)
				argv[(*argc)++] = strdup("-multi");
			if (app->heliosCV->IsDAO())
				argv[(*argc)++] = strdup("-dao");
			break;
		}
	}
	

	//argv[(*argc)]=NULL;
	return B_OK;
}
