#include "LIAM.h"
#include <string.h>


LIAM::LIAM() {
	dataMessage=new BMessage();
}

LIAM::~LIAM() {
	delete dataMessage;
}
		
		
// creating a language in a message
status_t	LIAM::AddCaption(const char *name, const char *caption) {
	return this->AddCaption(currentLanguage, name, caption);
}

status_t	LIAM::AddCaption(int32 language, const char *name, const char *caption) {
	if (dataMessage->ReplaceString(name, language, caption)==B_NAME_NOT_FOUND)
		dataMessage->AddString(name, "<empty>");
	while (dataMessage->ReplaceString(name, language, caption)==B_BAD_INDEX) {
		dataMessage->AddString(name, "<empty>");
	}
	return B_OK;
}

status_t	LIAM::SetLanguageName(const char *name) {
	return this->SetLanguageName(currentLanguage, name);
}

status_t	LIAM::SetLanguageName(int32 language, const char *name) {
	return this->AddCaption(language, "lIaMlAnGuAgEnAmE", name);
}

const char 	*LIAM::GetLanguageName() {
	return GetLanguageName(currentLanguage);
}

const char 	*LIAM::GetLanguageName(int32 language) {
	return this->GetCaption(language, "lIaMlAnGuAgEnAmE");	
}

int32		LIAM::CountCaptions() {
	return dataMessage->CountNames(B_STRING_TYPE)-this->CountLanguages();
}

int32		LIAM::CountLanguages() {
	type_code	tc;
	int32		count;

	if (dataMessage->GetInfo("lIaMlAnGuAgEnAmE", &tc, &count)==B_OK)
		return count;	
	else
		return 0;
}

BMessage	*LIAM::GetMessage() {
	return dataMessage;
}
		
// get the captions
status_t	LIAM::SetLanguage(int32 language) {
	currentLanguage=language;
	return B_OK;
}

int32		LIAM::GetLanguage() {
	return currentLanguage;
}
				
const char	*LIAM::GetCaption(int32 language, const char *name) {
	const char *string;
	
	if (dataMessage->FindString(name, language, &string)==B_OK)
		return strdup(string);
	else
		return "<empty>";
}

const char	*LIAM::GetCaption(const char *name) {
	return GetCaption(currentLanguage, name);
}
		
status_t	LIAM::LoadLIAM(BFile *file) {
	if (file->InitCheck()==B_OK)
		return dataMessage->Unflatten(file);
	else
		return B_ERROR;
}

status_t	LIAM::SaveLIAM(BFile *file) {
	status_t	initcheck;
	
	if ((initcheck=file->InitCheck())==B_OK)
		dataMessage->Flatten(file);
	return initcheck;
}

