#ifndef _LIAM_H_
#define _LIAM_H_

#include <Message.h>
#include <File.h>

class LIAM {
	public:
		LIAM();
		~LIAM();
		
		
		// creating a language in a message
		status_t	AddCaption(const char *name, const char *caption);
		status_t	AddCaption(int32 language, const char *name, const char *caption);
		status_t	SetLanguageName(const char *);
		status_t	SetLanguageName(int32, const char *);
		const char 	*GetLanguageName();
		const char 	*GetLanguageName(int32);
		int32		CountCaptions();
		int32		CountLanguages();
		
		BMessage	*GetMessage();
		
		// get the captions
		status_t	SetLanguage(int32);
		int32		GetLanguage();
				
		const char	*GetCaption(int32 language, const char *name);
		const char	*GetCaption(const char *name);
		
		status_t	LoadLIAM(BFile *);
		status_t	SaveLIAM(BFile *);
		
	private:
		
		int32		currentLanguage;
		BMessage	*dataMessage;
		
		
};


#endif

