#include "StandardConfigView.h"
#include "HLM.h"

extern HLM *H;

StandardConfigView::StandardConfigView() : ConfigView(){
	BFont *TCfont=new BFont(be_fixed_font);
	TCfont->SetSize(10.0);

	// TEXTCONTROLS
	publisherTC=new BTextControl(BRect(15,8,340,33),"scv_publisherTC",H->L("TPUBLISHER"), "",NULL);
	publisherTC->SetDivider(publisherTC->StringWidth(H->L("TPUBLISHER"))+5);
	publisherTC->TextView()->SetMaxBytes(128);
	publisherTC->TextView()->SetFontAndColor(TCfont);
	AddChild(publisherTC);

	preparerTC=new BTextControl(BRect(15,38,340,63),"scv_preparerTC",H->L("TPREPARER"), "",NULL);
	preparerTC->SetDivider(preparerTC->StringWidth(H->L("TPREPARER"))+5);
	preparerTC->TextView()->SetMaxBytes(128);
	preparerTC->TextView()->SetFontAndColor(TCfont);
	AddChild(preparerTC);

	applicationTC=new BTextControl(BRect(15,68,340,93),"scv_applicationTC",H->L("TAPPLICATION"), "",NULL);
	applicationTC->SetDivider(applicationTC->StringWidth(H->L("TAPPLICATION"))+5);
	applicationTC->TextView()->SetMaxBytes(128);
	applicationTC->TextView()->SetFontAndColor(TCfont);
	AddChild(applicationTC);

//	projectpathTC=new BrowseField(BRect(15,98,340,123),"scv_projectpathTC");//,H->L("TPROJECTPATH"), "",NULL);
//	projectpathTC->GetTextControl()->SetDivider(100);
//	projectpathTC->GetButton()->SetLabel(H->L("TBROWSE"));
//	projectpathTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE|B_DIRECTORY_NODE);
//	projectpathTC->GetTextControl()->SetLabel(H->L("TPROJECTPATH"));
//	projectpathTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	//AddChild(projectpathTC);

//	temppathTC=new BrowseField(BRect(15,128,340,153),"scv_temppathTC");//,H->L("TTEMPPATH"), "",NULL);
//	temppathTC->GetTextControl()->SetDivider(100);
//	temppathTC->GetButton()->SetLabel(H->L("TBROWSE"));
//	temppathTC->Init(H->L("C_SELECT"), NULL, B_FILE_NODE|B_DIRECTORY_NODE);
//	temppathTC->GetTextControl()->SetLabel(H->L("TTEMPPATH"));
//	temppathTC->GetTextControl()->TextView()->SetMaxBytes(8192);
	//AddChild(temppathTC);

	// FILESYSTEM MENU
	filesystemPUM=new BPopUpMenu("");
	filesystemMF=new BMenuField(BRect(15,98,230,123),"scv_filesystemMF", H->L("TFILESYSTEM"), filesystemPUM, false);
	filesystemMF->SetDivider(102);
	
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:ISO9660"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:ISO9660 long"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:BeOS bfs"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:MacOS hfs"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:Unix RockRidge"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:Windows Joliet"), NULL));
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:UDF"), NULL));
	filesystemPUM->AddSeparatorItem();
	filesystemPUM->AddItem(new BMenuItem(H->L("MI:Custom"), NULL));
	AddChild(filesystemMF);

	// VOLUMENAME
	volumenameTC=new BTextControl(BRect(15,128,340,153),"scv_volumenameTC",H->L("TVOLUMENAME"), "",NULL);
	volumenameTC->SetDivider(100);
	volumenameTC->TextView()->SetMaxBytes(8192);
	AddChild(volumenameTC);
	
	CDTypeM=new CDTypeMenu(BRect(15,158, 200, 183), NULL);
	CDTypeM->SetLabel(H->L("TDEFAULTDISCMODE"));
	CDTypeM->SetDivider(102);
	AddChild(CDTypeM);
}

StandardConfigView::~StandardConfigView() {
}

int32 StandardConfigView::GetFilesystem() {
	return filesystemPUM->IndexOf(filesystemPUM->FindMarked());
}

void StandardConfigView::SetFilesystem(int32 item) {
	if (filesystemPUM->ItemAt(item)!=NULL)
		(filesystemPUM->ItemAt(item))->SetMarked(true);
}

const char *StandardConfigView::GetVolumeName() {
	return volumenameTC->Text();
}

void StandardConfigView::SetVolumeName(const char *name) {
	volumenameTC->SetText(name);
}

int8 StandardConfigView::GetCDType() {
	return CDTypeM->GetMenu()->IndexOf(CDTypeM->GetMenu()->FindMarked());
}

void StandardConfigView::SetCDType(int8 type) {
	(CDTypeM->GetMenu()->ItemAt(type))->SetMarked(true);
}


const char *StandardConfigView::GetPublisher() {
	return publisherTC->Text();
}

void StandardConfigView::SetPublisher(const char *str) {
	publisherTC->SetText(str);
}

const char *StandardConfigView::GetPreparer() {
	return preparerTC->Text();
}

void StandardConfigView::SetPreparer(const char *str) {
	preparerTC->SetText(str);
}

const char *StandardConfigView::GetApplication() {
	return applicationTC->Text();
}

void StandardConfigView::SetApplication(const char *str) {
	applicationTC->SetText(str);
}

//const char *StandardConfigView::GetTemporaryPath() {
//	return temppathTC->GetTextControl()->Text();
//}
//
//void StandardConfigView::SetTemporaryPath(const char *path) {
//	temppathTC->GetTextControl()->SetText(path);
//}
//	
//const char *StandardConfigView::GetProjectPath() {
//	return projectpathTC->GetTextControl()->Text();
//}
//
//void StandardConfigView::SetProjectPath(const char *path) {
//	projectpathTC->GetTextControl()->SetText(path);
//}

// PRIVATE

void	StandardConfigView::MessageReceived(BMessage *msg) {
	switch(msg->what) {
		default: {
			BView::MessageReceived(msg);
			break;
		}
	}
}