#include <View.h>
#include "StatusView.h"
#include <ScrollBar.h>
#include <stdio.h>
#include <Application.h>
#include <stdlib.h>
#include "HLM.h"
#include <string.h>
#include <Roster.h>
#include "Defines.h"

extern HLM *H;

StatusView::StatusView(BColumnListView *owner) : BView(BRect(0,0,75,B_H_SCROLL_BAR_HEIGHT-1), "StatusView", B_FOLLOW_LEFT | B_FOLLOW_BOTTOM, B_WILL_DRAW) {
	SetViewColor((rgb_color){219, 219, 219, 255});
	GetFont(&font);
	font.SetSize(9);
	SetFont(&font, B_FONT_SIZE);
	fowner=owner;
	trashPressed=false;
	itemString=(char *)malloc(20);
	SetNumberOfItems(0);
	menuPOP=new BPopUpMenu("sv_menuPOP", false, false);
	
//	newfolderRect.right=90;
//	newfolderRect.top=1;
//	newfolderRect.bottom=B_H_SCROLL_BAR_HEIGHT-1;
//	newfolderRect.left=newfolderRect.right-(16);
//
//	trashRect.right=newfolderRect.right+17;
//	trashRect.top=1;
//	trashRect.bottom=B_H_SCROLL_BAR_HEIGHT-1;
//	trashRect.left=trashRect.right-(16);
	
	contextRect=Bounds();
	
	
//	const void	*ptr=NULL;
//	size_t	length;
//	entry_ref		ref;
//	
//	newfolderBM=new BBitmap(BRect(0,0,13,13), B_CMAP8);
//	if ((ptr = be_app->AppResources()->LoadResource('MICN', 1, &length))) {
//		newfolderBM->SetBits(ptr, length, 0, B_CMAP8);
//	}
//	trashBM=new BBitmap(BRect(0,0,13,13), B_CMAP8);
//	if ((ptr = be_app->AppResources()->LoadResource('MICN', 2, &length))) {
//		trashBM->SetBits(ptr, length, 0, B_CMAP8);
//	}
//
//	if (ptr)
//		memcpy(newfolderBM, ptr, length);
//if (ptr!=NULL)
	//newfolderBM->SetBits(ptr, 100, 0, B_CMAP8);
//	newfolderBM->SetBits(ptr, length, 0, B_RGBA32);
//newfolderBM=(BBitmap *)ptr;
}

StatusView::~StatusView() {
	free(itemString);
}

void StatusView::AddMenuItem(BMenuItem *item) {
	if (item) {
		item->SetTarget(be_app_messenger);
		menuPOP->AddItem(item);
	}
}

void StatusView::RemoveMenuItems() {
	while (menuPOP->CountItems()>0) menuPOP->RemoveItem(0L);
}

void StatusView::SetNumberOfItems(int32 number) {
	sprintf(itemString, "%ld %s", number, (number==1) ? H->L("TITEM") : H->L("TITEMS"));
	Invalidate();
}

void StatusView::DrawPressed(BBitmap *bm, BRect *rect) {
	SetHighColor(216, 216, 216);
	FillRect(*rect);		
	DrawBitmap(bm, BPoint(rect->left+2,rect->top+1));
	SetHighColor((rgb_color){152,152,152, 255});
	StrokeLine(BPoint(rect->right,1),BPoint(rect->right,rect->Height()+1));
}

void StatusView::Draw(BRect updateRect) {
	
	rgb_color	highcolor=HighColor();
	
	SetLowColor(219,219,219,255);
	SetHighColor((rgb_color){152,152,152, 255});
	StrokeLine(BPoint(0,0),BPoint(Bounds().Width(),0));
	StrokeLine(BPoint(contextRect.Width(),1),BPoint(contextRect.Width(),contextRect.Height()));
//	StrokeLine(BPoint(newfolderRect.right,1),BPoint(newfolderRect.right,newfolderRect.Height()+1));
	SetHighColor((rgb_color){255,255,255, 255});
	StrokeLine(BPoint(0,1),BPoint(contextRect.Width()-1,1));
	StrokeLine(BPoint(0,2),BPoint(0,contextRect.Height()));
	SetHighColor((rgb_color){0,0,0,255});
	DrawString(itemString, BPoint(4,contextRect.Height()-2));

//	DrawBitmap(newfolderBM, BPoint(newfolderRect.left+1,newfolderRect.top));
//	DrawBitmap(trashBM, BPoint(trashRect.left+1,trashRect.top));

	SetHighColor(highcolor);
	
	BView::Draw(updateRect);
}


void StatusView::MouseDown(BPoint point) {
//	if (contextRect.Contains(point))
		menuPOP->Go(ConvertToScreen(BPoint(Bounds().left, Bounds().bottom+2)), true, true, ConvertToScreen(Bounds()));
//	if (newfolderRect.Contains(point)) {
//		DrawPressed(newfolderBM, &newfolderRect);
//		be_app->PostMessage('mm12');
//		snooze(200000);
//		//DrawBitmap(newfolderBM, BPoint(newfolderRect.left+1,newfolderRect.top));
//	}
//	if (trashRect.Contains(point)) {
//		DrawPressed(trashBM, &trashRect);
//		be_app->PostMessage(DELETE_FILE_MSG);
//		snooze(200000);
//	}
}






