#include "StatusWindow.h"
#include "HLM.h"
#include <stdio.h>

extern HLM *H;

StatusWindow::StatusWindow(const char *text)
		: BWindow(BRect(0,0,250, 45), "sw_window", B_BORDERED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_CLOSABLE | B_NOT_ZOOMABLE | B_NOT_RESIZABLE) {
		
	mainV=new BView(Bounds(), "sw_mainV", B_FOLLOW_ALL, B_WILL_DRAW);
	mainV->SetViewColor(216, 216, 216);
	AddChild(mainV);
	
	textSV=new BStringView(BRect(2, 6, 248, 26), "sw_textSV", "", B_FOLLOW_V_CENTER | B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW | B_NAVIGABLE);
	textSV->SetAlignment(B_ALIGN_CENTER);
	textSV->SetFont(be_bold_font);
	textSV->SetFontSize(12);
	mainV->AddChild(textSV);
	
	filesSV=new BStringView(BRect(2, 27, 248, 43), "sw_filesSV", "", B_FOLLOW_V_CENTER | B_FOLLOW_LEFT_RIGHT, B_WILL_DRAW | B_NAVIGABLE);
	filesSV->SetAlignment(B_ALIGN_CENTER);
	filesSV->SetFont(be_plain_font);
	filesSV->SetFontSize(10);
	mainV->AddChild(filesSV);
	
	if (text!=NULL)
		SetText(text);
}


StatusWindow::~StatusWindow() {
}


void	StatusWindow::SetFileCounter(int32 files) {
	char text[25];
	
	filecounter=files;
	sprintf(text, "%ld %s", files, (files==1) ? H->L("TITEM") : H->L("TITEMS"));
	filesSV->SetText(text);
}

int32	StatusWindow::GetFiles() {
	return filecounter;
}

void	StatusWindow::SetText(const char *text) {
	textSV->SetText(text);
}

void	StatusWindow::Show() {
	SetWorkspaces(B_CURRENT_WORKSPACE);
	BWindow::Show();
}












